/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package lesson9;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

/**
 *
 * @author admin
 */
public class Group{

    private List<Team> teams = new ArrayList<>();

    public void addTeam(Team t) {
        teams.add(t);
    }

    public void removeTeam(Team t) {
        teams.remove(t);
    }

    /**
     * A method that returns the teams list sorted by their total points. The
     * implementation uses a simple instance of an implementation of the
     * Comparator interface
     */
    public void sortTeamListByPoints() {
        teams.sort(new TeamComparatorByPoints());
    }

    /**
     * A method that returns the teams list sorted by their total points. The
     * implementation uses an instance of an inner implementation of the Comparator interface
     */
    public void sortTeamListByPoints2() {
        InnerTeamComparator ic = new InnerTeamComparator();
        teams.sort(ic);
    }

    /**
     * The inner class implementing the Comparator interface
     */
    private class InnerTeamComparator implements Comparator<Team> {

        @Override
        public int compare(Team t, Team t1) {
            return t1.getPoints() - t.getPoints();
        }
    }

    /**
     * A method that returns the teams list sorted by their total points. The
     * implementation uses an anonymous implementation of the Comparator interface
     */
    public void sortTeamListByPoints3() {
        Comparator<Team> anonymousComparator = new Comparator<Team>() {
            @Override
            public int compare(Team t, Team t1) {
                return t1.getPoints() - t.getPoints();
            }
        };

        teams.sort(anonymousComparator);
    }

    @Override
    public String toString() {
        String value = "";
        for (Team t : teams)
            value += t + "\n";
        return value.substring(0, value.length()-1);
    }
}
